<?php
// $Id: teaserthumbnail.views.inc,v 1.3.2.4 2009/02/14 04:08:22 hunvreus Exp $
/**
 * Implementation of hook_views_tables():
 */
function teaserthumbnail_views_tables() {
  $tables['teaserthumbnail'] = array(
    'name' => 'teaserthumbnail',
    'join' => array(
      'left' => array(
        'table' => 'node',
        'field' => 'nid',
      ),
      'right' => array(
        'field' => 'nid',
      ),
    ),
    'fields' => array(
      'filepath' => array(
        'name' => t('Node: Teaser Thumbnail'),
        'sortable' => FALSE,
        'option' => array(
          '#type' => 'select',
          '#options' => array(
            'thumbnail_with_link' => t('Thumbnail with link'),
            'thumbnail_without_link' => t('Thumbnail without link'),
            'original_with_link' => t('Original with link'),
            'original_without_link' => t('Original without link'),
          )
        ),
        'handler' => 'views_handler_field_teaserthumbnail',
        'help' => t('Displays the teaser thumbnail associated to this node.'),
      ),
    ),
  );

  return $tables;
}

/**
 * Format a field as a teaser thumbnail
 */
function views_handler_field_teaserthumbnail($fieldinfo, $fielddata, $value, $data) {
  $result = db_fetch_object(db_query("SELECT t.filepath, n.type FROM {teaserthumbnail} t INNER JOIN {node} n ON n.nid = t.nid WHERE t.nid = %d", $data->nid));
  $thumbnail = $result->filepath;
  $type = $result->type;
  if (!empty($thumbnail)) {
    if ($fielddata['options'] == 'thumbnail_with_link' || $fielddata['options'] == 'thumbnail_without_link') {
      $node = NULL;
      $node->teaserthumbnail = $thumbnail;
      $node->type = $type;
      $thumbnail = theme('teaserthumbnail_thumbnail', $node);
    }
    else {
      $thumbnail = theme('image', $thumbnail);
    }
    if ($fielddata['options'] == 'thumbnail_with_link' || $fielddata['options'] == 'original_with_link') {
      $thumbnail = l($thumbnail, 'node/'. $data->nid, array(), NULL, NULL, FALSE, TRUE);
    }
    return $thumbnail;
  }
}